"use strict";

var _safeExtend = require("safe-extend");

var _safeExtend2 = _interopRequireDefault(_safeExtend);

var _defaultSettings = require("./defaultSettings");

var _defaultSettings2 = _interopRequireDefault(_defaultSettings);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Api = function Api(settings) {
    _classCallCheck(this, Api);

    settings = (0, _safeExtend2.default)(true, {}, _defaultSettings2.default.BetterAPI(), settings);
    this.settings = settings;
};

Api.prototype.create = function (createSettings) {
    var self = this;
    createSettings = (0, _safeExtend2.default)(true, {}, _defaultSettings2.default.create(), createSettings);
    return function request() {
        var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        var responseType = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        var callback = arguments[2];

        callback = (0, _safeExtend2.default)(true, {}, _defaultSettings2.default.request.callback(), callback);
        callback.before();
        var sendData = data;
        var fetchSettins = (0, _safeExtend2.default)(true, {}, self.settings.defaultSettings, createSettings.settings);
        var userCallbackDone = callback.net.done;
        var userCallbackFail = callback.net.fail;
        var failArg = [];
        sendData = self.settings.input(sendData);
        sendData = createSettings.input(sendData);
        self.settings.loading(true, failArg);
        createSettings.loading(true, failArg);
        callback.loading(true, failArg);
        callback.net.fail = function proxyFail() {
            for (var _len = arguments.length, arg = Array(_len), _key = 0; _key < _len; _key++) {
                arg[_key] = arguments[_key];
            }

            var command = {
                defaultAction: function defaultAction() {
                    self.settings.defaultCallback.net.fail.apply(null, arg);
                }
            };
            failArg = arg;
            if (typeof userCallbackFail === 'function') {
                userCallbackFail.apply(command, arg);
            } else {
                command.defaultAction();
            }
            self.settings.loading(false, failArg);
            createSettings.loading(false, failArg);
            callback.loading(false, failArg);
        };
        callback.net.done = function proxyDone(res) {
            var cloneRes = _safeExtend2.default.clone(res);
            self.settings.check(cloneRes, sendData, createSettings.settings);
            res = self.settings.output(res, sendData);
            res = createSettings.output(res, sendData);
            userCallbackDone.apply(null, [res]);
            var typeKey = self.settings.judgeResponseType.apply(null, [res]);
            var defaultResponse = self.settings.defaultResponseType[typeKey];
            var userResponse = responseType[typeKey];
            if (typeof createSettings.check[typeKey] === 'function') {
                createSettings.check[typeKey](cloneRes, sendData, createSettings.settings);
            }
            var command = {
                defaultAction: function defaultAction() {
                    defaultResponse(res);
                }
            };
            if (typeof defaultResponse === 'undefined' && typeof userResponse === 'undefined') {
                console.warn("node_modules/better-api: request(settings, callback); callback[\"" + typeKey + "\"] must be a function");
            } else {
                if (userResponse) {
                    userResponse.apply(command, [res]);
                } else {
                    command.defaultAction();
                }
            }
            self.settings.loading(false, failArg);
            createSettings.loading(false, failArg);
            callback.loading(false, failArg);
        };
        return self.settings.fetch(sendData, fetchSettins, callback);
    };
};
module.exports = Api;